'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path;

function _load_path() {
  return _path = _interopRequireWildcard(require('path'));
}

var _semver;

function _load_semver() {
  return _semver = _interopRequireDefault(require('semver'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _ramda2;

function _load_ramda2() {
  return _ramda2 = require('ramda');
}

var _toposortClass;

function _load_toposortClass() {
  return _toposortClass = _interopRequireDefault(require('toposort-class'));
}

var _globalConfig;

function _load_globalConfig() {
  return _globalConfig = require('../global-config');
}

var _enrichContextFromGlobal;

function _load_enrichContextFromGlobal() {
  return _enrichContextFromGlobal = _interopRequireDefault(require('../hooks/utils/enrich-context-from-global'));
}

var _flattenDependencies;

function _load_flattenDependencies() {
  return _flattenDependencies = require('./flatten-dependencies');
}

var _componentObjects;

function _load_componentObjects() {
  return _componentObjects = _interopRequireDefault(require('./component-objects'));
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('./models/component'));
}

var _source;

function _load_source() {
  return _source = _interopRequireDefault(require('./models/source'));
}

var _models;

function _load_models() {
  return _models = require('./models');
}

var _remotes;

function _load_remotes() {
  return _remotes = require('../remotes');
}

var _objectRegistrar;

function _load_objectRegistrar() {
  return _objectRegistrar = _interopRequireDefault(require('./object-registrar'));
}

var _utils;

function _load_utils() {
  return _utils = require('../utils');
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

var _scopeJson;

function _load_scopeJson() {
  return _scopeJson = require('./scope-json');
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = require('./exceptions');
}

var _environment;

function _load_environment() {
  return _environment = _interopRequireDefault(require('../environment'));
}

var _exceptions2;

function _load_exceptions2() {
  return _exceptions2 = require('./network/exceptions');
}

var _repositories;

function _load_repositories() {
  return _repositories = require('./repositories');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../bit-id');
}

var _component2;

function _load_component2() {
  return _component2 = _interopRequireDefault(require('../consumer/component'));
}

var _componentVersion;

function _load_componentVersion() {
  return _componentVersion = _interopRequireDefault(require('./component-version'));
}

var _objects;

function _load_objects() {
  return _objects = require('./objects');
}

var _componentDependencies;

function _load_componentDependencies() {
  return _componentDependencies = _interopRequireDefault(require('./component-dependencies'));
}

var _versionDependencies;

function _load_versionDependencies() {
  return _versionDependencies = _interopRequireDefault(require('./version-dependencies'));
}

var _sources;

function _load_sources() {
  return _sources = _interopRequireDefault(require('./repositories/sources'));
}

var _npmClient;

function _load_npmClient() {
  return _npmClient = _interopRequireDefault(require('../npm-client'));
}

var _consumer;

function _load_consumer() {
  return _consumer = _interopRequireDefault(require('../consumer/consumer'));
}

var _indexer;

function _load_indexer() {
  return _indexer = require('../search/indexer');
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../cli/loader'));
}

var _migrationHelper;

function _load_migrationHelper() {
  return _migrationHelper = require('../migration/migration-helper');
}

var _scopeMigratorManifest;

function _load_scopeMigratorManifest() {
  return _scopeMigratorManifest = _interopRequireDefault(require('./migrations/scope-migrator-manifest'));
}

var _scopeMigrator;

function _load_scopeMigrator() {
  return _scopeMigrator = _interopRequireDefault(require('./migrations/scope-migrator'));
}

var _scopeMigrator2;

function _load_scopeMigrator2() {
  return _scopeMigrator2 = require('./migrations/scope-migrator');
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../cli/loader/loader-messages');
}

var _ciOps;

function _load_ciOps() {
  return _ciOps = _interopRequireDefault(require('./ci-ops'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../logger/logger'));
}

var _componentResolver;

function _load_componentResolver() {
  return _componentResolver = _interopRequireDefault(require('../component-resolver'));
}

var _componentsList;

function _load_componentsList() {
  return _componentsList = _interopRequireDefault(require('../consumer/component/components-list'));
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var removeNils = (_ramda || _load_ramda()).default.reject((_ramda || _load_ramda()).default.isNil);
var pathHasScope = (0, (_utils || _load_utils()).pathHas)([(_constants || _load_constants()).OBJECTS_DIR, (_constants || _load_constants()).BIT_HIDDEN_DIR]);

var Scope = function () {
  // sources: SourcesRepository; // for some reason it interferes with the IDE autocomplete
  function Scope(scopeProps) {
    _classCallCheck(this, Scope);

    this.created = false;

    this.path = scopeProps.path;
    this.scopeJson = scopeProps.scopeJson;
    this.created = scopeProps.created || false;
    this.tmp = scopeProps.tmp || new (_repositories || _load_repositories()).Tmp(this);
    this.sources = scopeProps.sources || new (_sources || _load_sources()).default(this);
    this.objects = scopeProps.objects || new (_objects || _load_objects()).Repository(this, (0, (_objectRegistrar || _load_objectRegistrar()).default)());
  }

  _createClass(Scope, [{
    key: 'getPath',
    value: function getPath() {
      return this.path;
    }
  }, {
    key: 'getComponentsPath',
    value: function getComponentsPath() {
      return (_path || _load_path()).join(this.path, Scope.getComponentsRelativePath());
    }

    /**
     * Get the releative components path inside the scope
     * (components such as compilers / testers / extensions)
     * currently components
     */

  }, {
    key: 'getBitPathInComponentsDir',
    value: function getBitPathInComponentsDir(id) {
      return (_path || _load_path()).join(this.getComponentsPath(), id.toFullPath());
    }

    /**
     * Running migration process for scope to update the stores (bit objects) to the current version
     *
     * @param {any} verbose - print debug logs
     * @returns {Object} - wether the process run and wether it successeded
     * @memberof Consumer
     */

  }, {
    key: 'migrate',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(verbose) {
        var scopeVersion, rawObjects, resultObjects;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (_logger || _load_logger()).default.debug('running migration process for scope');
                if (verbose) console.log('running migration process for scope'); // eslint-disable-line
                // We start to use this process after version 0.10.9, so we assume the scope is in the last production version
                scopeVersion = this.scopeJson.get('version') || '0.10.9';

                if (!(_semver || _load_semver()).default.gte(scopeVersion, (_constants || _load_constants()).BIT_VERSION)) {
                  _context.next = 6;
                  break;
                }

                (_logger || _load_logger()).default.debug('scope version is up to date');
                return _context.abrupt('return', {
                  run: false
                });

              case 6:
                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_MIGRATION);
                _context.next = 9;
                return this.objects.listRawObjects();

              case 9:
                rawObjects = _context.sent;
                _context.next = 12;
                return (0, (_scopeMigrator || _load_scopeMigrator()).default)(scopeVersion, (_scopeMigratorManifest || _load_scopeMigratorManifest()).default, rawObjects, verbose);

              case 12:
                resultObjects = _context.sent;

                // Add the new / updated objects
                this.objects.addMany(resultObjects.newObjects);
                // Remove old objects
                _context.next = 16;
                return this.objects.removeMany(resultObjects.refsToRemove);

              case 16:
                _context.next = 18;
                return this.objects.persist();

              case 18:
                // Update the scope version
                this.scopeJson.set('version', (_constants || _load_constants()).BIT_VERSION);
                (_logger || _load_logger()).default.debug(`updating scope version to version ${(_constants || _load_constants()).BIT_VERSION}`);
                _context.next = 22;
                return this.scopeJson.write(this.getPath());

              case 22:
                return _context.abrupt('return', {
                  run: true,
                  success: true
                });

              case 23:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function migrate(_x) {
        return _ref.apply(this, arguments);
      }

      return migrate;
    }()
  }, {
    key: 'remotes',
    value: function remotes() {
      var self = this;
      function mergeRemotes(globalRemotes) {
        var globalObj = globalRemotes.toPlainObject();
        return (_remotes || _load_remotes()).Remotes.load((0, (_ramda2 || _load_ramda2()).merge)(globalObj, self.scopeJson.remotes));
      }

      return (_globalConfig || _load_globalConfig()).GlobalRemotes.load().then(mergeRemotes);
    }
  }, {
    key: 'describe',
    value: function describe() {
      return {
        name: this.name
      };
    }
  }, {
    key: 'toConsumerComponents',
    value: function toConsumerComponents(components) {
      var _this = this;

      return Promise.all(components.filter(function (comp) {
        return !(comp instanceof (_models || _load_models()).Symlink);
      }).map(function (c) {
        return c.toConsumerComponent(c.latestExisting(_this.objects).toString(), _this.name, _this.objects);
      }));
    }
  }, {
    key: 'list',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2() {
        var showRemoteVersion = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
        var components, consumerComponents, componentsIds, latestVersionsInfo;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.objects.listComponents();

              case 2:
                components = _context2.sent;
                _context2.next = 5;
                return this.toConsumerComponents(components);

              case 5:
                consumerComponents = _context2.sent;

                if (!showRemoteVersion) {
                  _context2.next = 12;
                  break;
                }

                componentsIds = consumerComponents.map(function (component) {
                  return component.id;
                });
                _context2.next = 10;
                return this.fetchRemoteVersions(componentsIds);

              case 10:
                latestVersionsInfo = _context2.sent;

                latestVersionsInfo.forEach(function (componentId) {
                  var component = consumerComponents.find(function (c) {
                    return c.id.toStringWithoutVersion() === componentId.toStringWithoutVersion();
                  });
                  component.latest = componentId.version;
                });

              case 12:
                return _context2.abrupt('return', (_componentsList || _load_componentsList()).default.sortComponentsByName(consumerComponents));

              case 13:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function list() {
        return _ref2.apply(this, arguments);
      }

      return list;
    }()
  }, {
    key: 'listStage',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3() {
        var _this2 = this;

        var components, scopeComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.objects.listComponents(false);

              case 2:
                components = _context3.sent;
                _context3.next = 5;
                return this.toConsumerComponents(components.filter(function (c) {
                  return !c.scope || c.scope === _this2.name;
                }));

              case 5:
                scopeComponents = _context3.sent;
                return _context3.abrupt('return', (_componentsList || _load_componentsList()).default.sortComponentsByName(scopeComponents));

              case 7:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function listStage() {
        return _ref3.apply(this, arguments);
      }

      return listStage;
    }()
  }, {
    key: 'fetchRemoteVersions',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(componentIds) {
        var _this3 = this;

        var externals, remotes;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                externals = componentIds.filter(function (id) {
                  return !id.isLocal(_this3.name);
                });
                _context4.next = 3;
                return this.remotes();

              case 3:
                remotes = _context4.sent;
                return _context4.abrupt('return', remotes.latestVersions(externals, this));

              case 5:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function fetchRemoteVersions(_x3) {
        return _ref4.apply(this, arguments);
      }

      return fetchRemoteVersions;
    }()
  }, {
    key: 'latestVersions',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(componentIds) {
        var throwOnFailure = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var components;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                componentIds = componentIds.map(function (componentId) {
                  return (_bitId || _load_bitId()).BitId.parse(componentId.toStringWithoutVersion());
                });
                _context5.next = 3;
                return this.sources.getMany(componentIds);

              case 3:
                components = _context5.sent;
                return _context5.abrupt('return', components.map(function (component) {
                  var componentId = (_bitId || _load_bitId()).BitId.parse(component.id.toString());
                  if (component.component) {
                    componentId.version = component.component.latest();
                  } else {
                    if (throwOnFailure) throw new (_exceptions || _load_exceptions()).ComponentNotFound(component.id.toString());
                    componentId.version = (_constants || _load_constants()).DEFAULT_BIT_VERSION;
                  }
                  return componentId;
                }));

              case 5:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function latestVersions(_x5) {
        return _ref5.apply(this, arguments);
      }

      return latestVersions;
    }()
  }, {
    key: 'importDependencies',
    value: function importDependencies(dependencies) {
      var _this4 = this;

      return new Promise(function (resolve, reject) {
        return _this4.importMany(dependencies).then(resolve).catch(function (e) {
          (_logger || _load_logger()).default.error(`importDependencies got an error: ${JSON.stringify(e)}`);
          if (e instanceof (_exceptions2 || _load_exceptions2()).RemoteScopeNotFound || e instanceof (_exceptions2 || _load_exceptions2()).PermissionDenied) return reject(e);
          return reject(new (_exceptions || _load_exceptions()).DependencyNotFound(e.id));
        });
      });
    }
  }, {
    key: 'putMany',
    value: function () {
      var _ref7 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee8(_ref6) {
        var _this5 = this;

        var consumerComponents = _ref6.consumerComponents,
            message = _ref6.message,
            exactVersion = _ref6.exactVersion,
            releaseType = _ref6.releaseType,
            force = _ref6.force,
            consumer = _ref6.consumer,
            verbose = _ref6.verbose;

        var topSort, allDependencies, consumerComponentsIdsMap, sortedConsumerComponentsIds, getFlattenForComponent, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, consumerComponentId, _consumerComponent, specsResults, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, _consumerComponentId, _consumerComponent2, persistComponentsP, components;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                // TODO: Change the return type
                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_IMPORT_PUT_ON_SCOPE);
                topSort = new (_toposortClass || _load_toposortClass()).default();
                allDependencies = new Map();
                consumerComponentsIdsMap = new Map();

                // Concat and unique all the dependencies from all the components so we will not import
                // the same dependency more then once, it's mainly for performance purpose

                consumerComponents.forEach(function (consumerComponent) {
                  var componentIdString = consumerComponent.id.toString();
                  // Store it in a map so we can take it easily from the sorted array which contain only the id
                  consumerComponentsIdsMap.set(componentIdString, consumerComponent);
                  var dependenciesIdsStrings = consumerComponent.dependencies.map(function (dependency) {
                    return dependency.id.toString();
                  });
                  topSort.add(componentIdString, dependenciesIdsStrings || []);
                });

                // Sort the consumerComponents by the dependency order so we can commit those without the dependencies first
                sortedConsumerComponentsIds = topSort.sort().reverse();

                getFlattenForComponent = function getFlattenForComponent(consumerComponent, cache) {
                  var flattenedDependenciesP = consumerComponent.dependencies.map(function () {
                    var _ref8 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee6(dependency) {
                      var flattenedDependencies, versionDependencies;
                      return (_regenerator || _load_regenerator()).default.wrap(function _callee6$(_context6) {
                        while (1) {
                          switch (_context6.prev = _context6.next) {
                            case 0:
                              // Try to get the flatten dependencies from cache
                              flattenedDependencies = cache.get(dependency.id.toString());

                              if (!flattenedDependencies) {
                                _context6.next = 3;
                                break;
                              }

                              return _context6.abrupt('return', Promise.resolve(flattenedDependencies));

                            case 3:
                              _context6.next = 5;
                              return _this5.importDependencies([dependency.id]);

                            case 5:
                              versionDependencies = _context6.sent;

                              // Copy the exact version from flattenedDependency to dependencies
                              if (!dependency.id.hasVersion()) {
                                dependency.id.version = (0, (_utils || _load_utils()).first)(versionDependencies).component.version;
                              }

                              _context6.next = 9;
                              return (0, (_flattenDependencies || _load_flattenDependencies()).flattenDependencyIds)(versionDependencies, _this5.objects);

                            case 9:
                              flattenedDependencies = _context6.sent;


                              // Store the flatten dependencies in cache
                              cache.set(dependency.id.toString(), flattenedDependencies);

                              return _context6.abrupt('return', flattenedDependencies);

                            case 12:
                            case 'end':
                              return _context6.stop();
                          }
                        }
                      }, _callee6, _this5);
                    }));

                    return function (_x7) {
                      return _ref8.apply(this, arguments);
                    };
                  }());
                  return Promise.all(flattenedDependenciesP);
                };

                // @todo: to make them all run in parallel, we have to first get all compilers from all components, install all
                // environments, then build them all. Otherwise, it'll try to npm-install the same compiler multiple times


                (_logger || _load_logger()).default.debug('scope.putMany: sequentially build all components');
                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_RUNNING_BUILD);
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context8.prev = 12;
                _iterator = sortedConsumerComponentsIds[Symbol.iterator]();

              case 14:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context8.next = 23;
                  break;
                }

                consumerComponentId = _step.value;
                _consumerComponent = consumerComponentsIdsMap.get(consumerComponentId);

                if (!_consumerComponent) {
                  _context8.next = 20;
                  break;
                }

                _context8.next = 20;
                return _consumerComponent.build({ scope: this, consumer });

              case 20:
                _iteratorNormalCompletion = true;
                _context8.next = 14;
                break;

              case 23:
                _context8.next = 29;
                break;

              case 25:
                _context8.prev = 25;
                _context8.t0 = _context8['catch'](12);
                _didIteratorError = true;
                _iteratorError = _context8.t0;

              case 29:
                _context8.prev = 29;
                _context8.prev = 30;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 32:
                _context8.prev = 32;

                if (!_didIteratorError) {
                  _context8.next = 35;
                  break;
                }

                throw _iteratorError;

              case 35:
                return _context8.finish(32);

              case 36:
                return _context8.finish(29);

              case 37:

                (_logger || _load_logger()).default.debug('scope.putMany: sequentially test all components');
                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_RUNNING_SPECS);
                specsResults = {};
                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context8.prev = 43;
                _iterator2 = sortedConsumerComponentsIds[Symbol.iterator]();

              case 45:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context8.next = 55;
                  break;
                }

                _consumerComponentId = _step2.value;
                _consumerComponent2 = consumerComponentsIdsMap.get(_consumerComponentId);

                if (!_consumerComponent2) {
                  _context8.next = 52;
                  break;
                }

                _context8.next = 51;
                return _consumerComponent2.runSpecs({
                  scope: this,
                  rejectOnFailure: !force,
                  consumer,
                  verbose
                });

              case 51:
                specsResults[_consumerComponentId] = _context8.sent;

              case 52:
                _iteratorNormalCompletion2 = true;
                _context8.next = 45;
                break;

              case 55:
                _context8.next = 61;
                break;

              case 57:
                _context8.prev = 57;
                _context8.t1 = _context8['catch'](43);
                _didIteratorError2 = true;
                _iteratorError2 = _context8.t1;

              case 61:
                _context8.prev = 61;
                _context8.prev = 62;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 64:
                _context8.prev = 64;

                if (!_didIteratorError2) {
                  _context8.next = 67;
                  break;
                }

                throw _iteratorError2;

              case 67:
                return _context8.finish(64);

              case 68:
                return _context8.finish(61);

              case 69:

                (_logger || _load_logger()).default.debug('scope.putMany: sequentially persist all components');
                persistComponentsP = sortedConsumerComponentsIds.map(function (consumerComponentId) {
                  return _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee7() {
                    var consumerComponent, flattenedDependencies, predicate, dists, component, deps;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee7$(_context7) {
                      while (1) {
                        switch (_context7.prev = _context7.next) {
                          case 0:
                            consumerComponent = consumerComponentsIdsMap.get(consumerComponentId);
                            // This happens when there is a dependency which have been already committed

                            if (consumerComponent) {
                              _context7.next = 3;
                              break;
                            }

                            return _context7.abrupt('return', Promise.resolve([]));

                          case 3:
                            _context7.next = 5;
                            return getFlattenForComponent(consumerComponent, allDependencies);

                          case 5:
                            flattenedDependencies = _context7.sent;

                            flattenedDependencies = (_ramda || _load_ramda()).default.flatten(flattenedDependencies);

                            predicate = function predicate(id) {
                              return id.toString();
                            }; // TODO: should be moved to BitId class


                            flattenedDependencies = (_ramda || _load_ramda()).default.uniqBy(predicate)(flattenedDependencies);

                            dists = consumerComponent.dists && consumerComponent.dists.length ? consumerComponent.dists.map(function (dist) {
                              return {
                                name: dist.basename,
                                relativePath: (0, (_utils || _load_utils()).pathNormalizeToLinux)(dist.relative),
                                file: (_source || _load_source()).default.from(dist.contents),
                                test: dist.test
                              };
                            }) : null;
                            _context7.next = 12;
                            return _this5.sources.addSource({
                              source: consumerComponent,
                              depIds: flattenedDependencies,
                              message,
                              exactVersion,
                              releaseType,
                              dists,
                              specsResults: specsResults[consumerComponentId]
                            });

                          case 12:
                            component = _context7.sent;
                            _context7.next = 15;
                            return component.toVersionDependencies((_constants || _load_constants()).LATEST, _this5, _this5.name);

                          case 15:
                            deps = _context7.sent;

                            consumerComponent.version = deps.component.version;
                            _context7.next = 19;
                            return deps.toConsumer(_this5.objects);

                          case 19:
                            return _context7.abrupt('return', consumerComponent);

                          case 20:
                          case 'end':
                            return _context7.stop();
                        }
                      }
                    }, _callee7, _this5);
                  }));
                });

                // Run the persistence one by one not in parallel!

                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_PERSISTING_PUT_ON_SCOPE);
                _context8.next = 74;
                return persistComponentsP.reduce(function (promise, func) {
                  return promise.then(function (result) {
                    return func().then(Array.prototype.concat.bind(result));
                  });
                }, Promise.resolve([]));

              case 74:
                components = _context8.sent;
                _context8.next = 77;
                return this.objects.persist();

              case 77:
                return _context8.abrupt('return', components);

              case 78:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this, [[12, 25, 29, 37], [30,, 32, 36], [43, 57, 61, 69], [62,, 64, 68]]);
      }));

      function putMany(_x6) {
        return _ref7.apply(this, arguments);
      }

      return putMany;
    }()

    /**
     * Writes a component as an object into the 'objects' directory
     */

  }, {
    key: 'writeComponentToModel',
    value: function writeComponentToModel(componentObjects) {
      var _this6 = this;

      var objects = componentObjects.toObjects(this.objects);
      (_logger || _load_logger()).default.debug(`writeComponentToModel, writing into the model, Main id: ${objects.component.id()}. It might have dependencies which are going to be written too`);
      return this.sources.merge(objects).then(function () {
        return _this6.objects.persist();
      });
    }

    /**
     * Writes components as objects into the 'objects' directory
     */

  }, {
    key: 'writeManyComponentsToModel',
    value: function () {
      var _ref10 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee9(componentsObjects) {
        var _this7 = this;

        var persist = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var manyObjects;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                manyObjects = componentsObjects.map(function (componentObjects) {
                  return componentObjects.toObjects(_this7.objects);
                });

                (_logger || _load_logger()).default.debug(`writeComponentToModel, writing into the model, ids: ${manyObjects.map(function (objects) {
                  return objects.component.id();
                }).join(', ')}. They might have dependencies which are going to be written too`);
                _context9.next = 4;
                return Promise.all(manyObjects.map(function (objects) {
                  return _this7.sources.merge(objects);
                }));

              case 4:
                return _context9.abrupt('return', persist ? this.objects.persist() : Promise.resolve());

              case 5:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function writeManyComponentsToModel(_x9) {
        return _ref10.apply(this, arguments);
      }

      return writeManyComponentsToModel;
    }()

    /**
     * When exporting components with dependencies to a bare-scope, some of the dependencies may be created locally and as
     * as result their scope-name is null. Once the bare-scope gets the components, it needs to convert these scope names
     * to the bare-scope name.
     * Since the changes it does affect the Version objects, the version REF of a component, needs to be changed as well.
     */

  }, {
    key: '_convertNonScopeToCorrectScope',
    value: function _convertNonScopeToCorrectScope(componentsObjects, remoteScope) {
      var _this8 = this;

      var changeScopeIfNeeded = function changeScopeIfNeeded(dependencyId) {
        if (!dependencyId.scope) {
          var depId = (_component || _load_component()).default.fromBitId(dependencyId);
          // todo: use 'load' for async and switch the foreach with map.
          var dependencyObject = _this8.objects.loadSync(depId.hash());
          if (dependencyObject instanceof (_models || _load_models()).Symlink) {
            dependencyId.scope = dependencyObject.realScope;
          } else {
            dependencyId.scope = remoteScope;
          }
        }
      };

      componentsObjects.objects.forEach(function (object) {
        if (object instanceof (_models || _load_models()).Version) {
          var hashBefore = object.hash().toString();
          object.dependencies.forEach(function (dependency) {
            changeScopeIfNeeded(dependency.id);
          });
          object.flattenedDependencies.forEach(function (dependency) {
            changeScopeIfNeeded(dependency);
          });
          var hashAfter = object.hash().toString();
          if (hashBefore !== hashAfter) {
            (_logger || _load_logger()).default.debug(`switching ${componentsObjects.component.id()} version hash from ${hashBefore} to ${hashAfter}`);
            var versions = componentsObjects.component.versions;
            Object.keys(versions).forEach(function (version) {
              if (versions[version].toString() === hashBefore) {
                versions[version] = (_objects || _load_objects()).Ref.from(hashAfter);
              }
            });
          }
        }
      });

      componentsObjects.component.scope = remoteScope;
    }

    /**
     * @TODO there is no real difference between bare scope and a working directory scope - let's adjust terminology to avoid confusions in the future
     * saves a component into the objects directory of the remote scope, then, resolves its
     * dependencies, saves them as well. Finally runs the build process if needed on an isolated
     * environment.
     */

  }, {
    key: 'exportManyBareScope',
    value: function () {
      var _ref11 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee10(componentsObjects) {
        var _this9 = this;

        var manyObjects, manyCompVersions, versions, manyConsumerComponent, ids;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`exportManyBareScope: Going to save ${componentsObjects.length} components`);
                manyObjects = componentsObjects.map(function (componentObjects) {
                  return componentObjects.toObjects(_this9.objects);
                });
                _context10.next = 4;
                return Promise.all(manyObjects.map(function (objects) {
                  return _this9.sources.merge(objects, true);
                }));

              case 4:
                _context10.next = 6;
                return Promise.all(manyObjects.map(function (objects) {
                  return objects.component.toComponentVersion((_constants || _load_constants()).LATEST);
                }));

              case 6:
                manyCompVersions = _context10.sent;

                (_logger || _load_logger()).default.debug('exportManyBareScope: will try to importMany in case there are missing dependencies');
                _context10.next = 10;
                return this.importMany(manyCompVersions.map(function (compVersion) {
                  return compVersion.id;
                }), undefined, true, false);

              case 10:
                versions = _context10.sent;
                // resolve dependencies
                (_logger || _load_logger()).default.debug('exportManyBareScope: successfully ran importMany');
                _context10.next = 14;
                return this.objects.persist();

              case 14:
                _context10.next = 16;
                return Promise.all(versions.map(function (version) {
                  return version.toObjects(_this9.objects);
                }));

              case 16:
                _context10.next = 18;
                return Promise.all(manyCompVersions.map(function (compVersion) {
                  return compVersion.toConsumer(_this9.objects);
                }));

              case 18:
                manyConsumerComponent = _context10.sent;

                // await Promise.all(manyConsumerComponent.map(consumerComponent => index(consumerComponent, this.getPath())));
                ids = manyConsumerComponent.map(function (consumerComponent) {
                  return consumerComponent.id.toString();
                });
                _context10.next = 22;
                return Promise.all(manyConsumerComponent.map(function (consumerComponent) {
                  return (0, (_ciOps || _load_ciOps()).default)(consumerComponent, _this9.getPath());
                }));

              case 22:
                return _context10.abrupt('return', ids);

              case 23:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function exportManyBareScope(_x10) {
        return _ref11.apply(this, arguments);
      }

      return exportManyBareScope;
    }()
  }, {
    key: 'getExternalOnes',
    value: function getExternalOnes(ids, remotes) {
      var _this10 = this;

      var localFetch = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var context = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

      (_logger || _load_logger()).default.debug(`getExternalOnes, ids: ${ids.join(', ')}`);
      (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(context);
      return this.sources.getMany(ids).then(function (defs) {
        var left = defs.filter(function (def) {
          if (!localFetch) return true;
          if (!def.component) return true;
          return false;
        });

        if (left.length === 0) {
          (_logger || _load_logger()).default.debug('getExternalOnes: no more ids left, all found locally, existing the method');
          return Promise.all(defs.map(function (def) {
            return def.component.toComponentVersion(def.id.version);
          }));
        }

        (_logger || _load_logger()).default.debug(`getExternalOnes: ${left.length} left. Fetching them from a remote`);
        return remotes.fetch(left.map(function (def) {
          return def.id;
        }), _this10, true, context).then(function (componentObjects) {
          return _this10.writeManyComponentsToModel(componentObjects);
        }).then(function () {
          return _this10.getExternalOnes(ids, remotes, true);
        });
      });
    }

    /**
     * If found locally, use them. Otherwise, fetch from remote and then, save into the model.
     */

  }, {
    key: 'getExternalMany',
    value: function getExternalMany(ids, remotes) {
      var localFetch = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      var _this11 = this;

      var persist = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
      var context = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};

      (_logger || _load_logger()).default.debug(`getExternalMany, planning on fetching from ${localFetch ? 'local' : 'remote'} scope. Ids: ${ids.join(', ')}`);
      (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(context);
      return this.sources.getMany(ids).then(function (defs) {
        var left = defs.filter(function (def) {
          if (!localFetch) return true;
          if (!def.component) return true;
          return false;
        });

        if (left.length === 0) {
          (_logger || _load_logger()).default.debug('getExternalMany: no more ids left, all found locally, existing the method');
          // $FlowFixMe - there should be a component because there no defs without components left.
          return Promise.all(defs.map(function (def) {
            return def.component.toVersionDependencies(def.id.version, _this11, def.id.scope);
          }));
        }

        (_logger || _load_logger()).default.debug(`getExternalMany: ${left.length} left. Fetching them from a remote`);
        return remotes.fetch(left.map(function (def) {
          return def.id;
        }), _this11, undefined, context).then(function (componentObjects) {
          (_logger || _load_logger()).default.debug('getExternalMany: writing them to the model');
          return _this11.writeManyComponentsToModel(componentObjects, persist);
        }).then(function () {
          return _this11.getExternalMany(ids, remotes);
        });
      });
    }

    /**
     * If the component is not in the local scope, fetch it from a remote and save into the local
     * scope. (objects directory).
     */

  }, {
    key: 'getExternal',
    value: function getExternal(_ref12) {
      var _this12 = this;

      var id = _ref12.id,
          remotes = _ref12.remotes,
          _ref12$localFetch = _ref12.localFetch,
          localFetch = _ref12$localFetch === undefined ? true : _ref12$localFetch,
          _ref12$context = _ref12.context,
          context = _ref12$context === undefined ? {} : _ref12$context;

      (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(context);
      return this.sources.get(id).then(function (component) {
        if (component && localFetch) {
          return component.toVersionDependencies(id.version, _this12, id.scope);
        }

        return remotes.fetch([id], _this12, undefined, context).then(function (_ref13) {
          var _ref14 = _slicedToArray(_ref13, 1),
              componentObjects = _ref14[0];

          return _this12.writeComponentToModel(componentObjects);
        }).then(function () {
          return _this12.getExternal({ id, remotes, localFetch: true });
        });
      });
    }
  }, {
    key: 'getExternalOne',
    value: function getExternalOne(_ref15) {
      var _this13 = this;

      var id = _ref15.id,
          remotes = _ref15.remotes,
          _ref15$localFetch = _ref15.localFetch,
          localFetch = _ref15$localFetch === undefined ? true : _ref15$localFetch,
          _ref15$context = _ref15.context,
          context = _ref15$context === undefined ? {} : _ref15$context;

      return this.sources.get(id).then(function (component) {
        if (component && localFetch) return component.toComponentVersion(id.version);
        return remotes.fetch([id], _this13, true, context).then(function (_ref16) {
          var _ref17 = _slicedToArray(_ref16, 1),
              componentObjects = _ref17[0];

          return _this13.writeComponentToModel(componentObjects);
        }).then(function () {
          return _this13.getExternal({ id, remotes, localFetch: true });
        });
      });
    }
  }, {
    key: 'getObjects',
    value: function () {
      var _ref18 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee11(ids, withDevDependencies) {
        var _this14 = this;

        var versions;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return this.importMany(ids, withDevDependencies);

              case 2:
                versions = _context11.sent;
                return _context11.abrupt('return', Promise.all(versions.map(function (version) {
                  return version.toObjects(_this14.objects);
                })));

              case 4:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function getObjects(_x16, _x17) {
        return _ref18.apply(this, arguments);
      }

      return getObjects;
    }()
  }, {
    key: 'getObject',
    value: function getObject(hash) {
      return new (_objects || _load_objects()).Ref(hash).load(this.objects);
    }
  }, {
    key: 'getRawObject',
    value: function getRawObject(hash) {
      return this.objects.loadRawObject(new (_objects || _load_objects()).Ref(hash));
    }

    /**
     * 1. Local objects, fetch from local. (done by this.sources.getMany method)
     * 2. Fetch flattened dependencies (done by toVersionDependencies method). If they're not locally, fetch from remote
     * and save them locally.
     * 3. External objects, fetch from a remote and save locally. (done by this.getExternalOnes method).
     */

  }, {
    key: 'importMany',
    value: function () {
      var _ref19 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee12(ids, withEnvironments) {
        var _this15 = this;

        var cache = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
        var persist = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;

        var idsWithoutNils, _splitWhen, _splitWhen2, externals, locals, localDefs, versionDeps, remotes, externalDeps;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.importMany: ${ids.join(', ')}`);
                idsWithoutNils = removeNils(ids);

                if (!(_ramda || _load_ramda()).default.isEmpty(idsWithoutNils)) {
                  _context12.next = 4;
                  break;
                }

                return _context12.abrupt('return', Promise.resolve([]));

              case 4:
                _splitWhen = (0, (_ramda2 || _load_ramda2()).splitWhen)(function (id) {
                  return id.isLocal(_this15.name);
                }, idsWithoutNils), _splitWhen2 = _slicedToArray(_splitWhen, 2), externals = _splitWhen2[0], locals = _splitWhen2[1];
                _context12.next = 7;
                return this.sources.getMany(locals);

              case 7:
                localDefs = _context12.sent;
                _context12.next = 10;
                return Promise.all(localDefs.map(function (def) {
                  if (!def.component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(def.id.toString());
                  return def.component.toVersionDependencies(def.id.version, _this15, def.id.scope, withEnvironments);
                }));

              case 10:
                versionDeps = _context12.sent;

                (_logger || _load_logger()).default.debug('scope.importMany: successfully fetched local components and their dependencies. Going to fetch externals');
                _context12.next = 14;
                return this.remotes();

              case 14:
                remotes = _context12.sent;
                _context12.next = 17;
                return this.getExternalMany(externals, remotes, cache, persist);

              case 17:
                externalDeps = _context12.sent;
                return _context12.abrupt('return', versionDeps.concat(externalDeps));

              case 19:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function importMany(_x20, _x21) {
        return _ref19.apply(this, arguments);
      }

      return importMany;
    }()
  }, {
    key: 'importManyOnes',
    value: function () {
      var _ref20 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee13(ids, cache) {
        var _this16 = this;

        var idsWithoutNils, _splitBy, _splitBy2, externals, locals, localDefs, componentVersionArr, remotes, externalDeps;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.importManyOnes. Ids: ${ids.join(', ')}`);
                idsWithoutNils = removeNils(ids);

                if (!(_ramda || _load_ramda()).default.isEmpty(idsWithoutNils)) {
                  _context13.next = 4;
                  break;
                }

                return _context13.abrupt('return', Promise.resolve([]));

              case 4:
                _splitBy = (0, (_utils || _load_utils()).splitBy)(idsWithoutNils, function (id) {
                  return id.isLocal(_this16.name);
                }), _splitBy2 = _slicedToArray(_splitBy, 2), externals = _splitBy2[0], locals = _splitBy2[1];
                _context13.next = 7;
                return this.sources.getMany(locals);

              case 7:
                localDefs = _context13.sent;
                _context13.next = 10;
                return Promise.all(localDefs.map(function (def) {
                  if (!def.component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(def.id.toString());
                  return def.component.toComponentVersion(def.id.version);
                }));

              case 10:
                componentVersionArr = _context13.sent;
                _context13.next = 13;
                return this.remotes();

              case 13:
                remotes = _context13.sent;
                _context13.next = 16;
                return this.getExternalOnes(externals, remotes, cache);

              case 16:
                externalDeps = _context13.sent;
                return _context13.abrupt('return', componentVersionArr.concat(externalDeps));

              case 18:
              case 'end':
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function importManyOnes(_x22, _x23) {
        return _ref20.apply(this, arguments);
      }

      return importManyOnes;
    }()
  }, {
    key: 'manyOneObjects',
    value: function manyOneObjects(ids) {
      var _this17 = this;

      return this.importManyOnes(ids).then(function (componentVersions) {
        return Promise.all(componentVersions.map(function (version) {
          return version.toObjects(_this17.objects);
        }));
      });
    }
  }, {
    key: 'import',
    value: function _import(id) {
      var _this18 = this;

      if (!id.isLocal(this.name)) {
        return this.remotes().then(function (remotes) {
          return _this18.getExternal({ id, remotes, localFetch: true });
        });
      }

      return this.sources.get(id).then(function (component) {
        if (!component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return component.toVersionDependencies(id.version, _this18, _this18.name);
      });
    }
  }, {
    key: 'get',
    value: function () {
      var _ref21 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee14(id) {
        var _this19 = this;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                return _context14.abrupt('return', this.import(id).then(function (versionDependencies) {
                  return versionDependencies.toConsumer(_this19.objects);
                }));

              case 1:
              case 'end':
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function get(_x24) {
        return _ref21.apply(this, arguments);
      }

      return get;
    }()

    /**
     * return a component only when it's stored locally. Don't go to any remote server and don't throw an exception if the
     * component is not there.
     */

  }, {
    key: 'getFromLocalIfExist',
    value: function () {
      var _ref22 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee15(id) {
        var componentFromSources, versionDependencies;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                _context15.next = 2;
                return this.sources.get(id);

              case 2:
                componentFromSources = _context15.sent;

                if (componentFromSources) {
                  _context15.next = 5;
                  break;
                }

                return _context15.abrupt('return', null);

              case 5:
                _context15.next = 7;
                return componentFromSources.toVersionDependencies(id.version, this, this.name);

              case 7:
                versionDependencies = _context15.sent;
                return _context15.abrupt('return', versionDependencies.toConsumer(this.objects));

              case 9:
              case 'end':
                return _context15.stop();
            }
          }
        }, _callee15, this);
      }));

      function getFromLocalIfExist(_x25) {
        return _ref22.apply(this, arguments);
      }

      return getFromLocalIfExist;
    }()

    /**
     * get multiple components from a scope, if not found in the local scope, fetch from a remote
     * scope. Then, write them to the local scope.
     */

  }, {
    key: 'getMany',
    value: function getMany(ids) {
      var _this20 = this;

      var cache = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      (_logger || _load_logger()).default.debug(`scope.getMany, Ids: ${ids.join(', ')}`);
      var idsWithoutNils = removeNils(ids);
      if ((_ramda || _load_ramda()).default.isEmpty(idsWithoutNils)) return Promise.resolve([]);
      return this.importMany(idsWithoutNils, false, cache).then(function (versionDependenciesArr) {
        return Promise.all(versionDependenciesArr.map(function (versionDependencies) {
          return versionDependencies.toConsumer(_this20.objects);
        }));
      });
    }

    // todo: improve performance by finding all versions needed and fetching them in one request from the server
    // currently it goes to the server twice. First, it asks for the last version of each id, and then it goes again to
    // ask for the older versions.

  }, {
    key: 'getManyWithAllVersions',
    value: function () {
      var _ref23 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee16(ids) {
        var _this21 = this;

        var cache = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var idsWithoutNils, versionDependenciesArr, allVersionsP;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.getManyWithAllVersions, Ids: ${ids.join(', ')}`);
                idsWithoutNils = removeNils(ids);

                if (!(_ramda || _load_ramda()).default.isEmpty(idsWithoutNils)) {
                  _context16.next = 4;
                  break;
                }

                return _context16.abrupt('return', Promise.resolve([]));

              case 4:
                _context16.next = 6;
                return this.importMany(idsWithoutNils, false, cache);

              case 6:
                versionDependenciesArr = _context16.sent;
                allVersionsP = versionDependenciesArr.map(function (versionDependencies) {
                  var versions = versionDependencies.component.component.listVersions();
                  var idsWithAllVersions = versions.map(function (version) {
                    if (version === versionDependencies.component.version) return null; // imported already
                    var versionId = versionDependencies.component.id;
                    versionId.version = version;
                    return versionId;
                  });
                  return _this21.importManyOnes(idsWithAllVersions);
                });
                _context16.next = 10;
                return Promise.all(allVersionsP);

              case 10:
                return _context16.abrupt('return', Promise.all(versionDependenciesArr.map(function (versionDependencies) {
                  return versionDependencies.toConsumer(_this21.objects);
                })));

              case 11:
              case 'end':
                return _context16.stop();
            }
          }
        }, _callee16, this);
      }));

      function getManyWithAllVersions(_x28) {
        return _ref23.apply(this, arguments);
      }

      return getManyWithAllVersions;
    }()

    /**
     * Remove or deprecate single component
     * @removeComponent - boolean - true if you want to remove component
     */

  }, {
    key: 'removeSingle',
    value: function () {
      var _ref24 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee17(bitId) {
        var componentList, symlink;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee17$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`removing ${bitId.toString()}`);
                _context17.next = 3;
                return this.objects.listComponents();

              case 3:
                componentList = _context17.sent;
                symlink = componentList.filter(function (link) {
                  return link instanceof (_models || _load_models()).Symlink && link.id() === bitId.toStringWithoutScopeAndVersion();
                });
                _context17.next = 7;
                return this.sources.clean(bitId, true);

              case 7:
                if ((_ramda || _load_ramda()).default.isEmpty(symlink)) {
                  _context17.next = 10;
                  break;
                }

                _context17.next = 10;
                return this.objects.remove(symlink[0].hash());

              case 10:
                return _context17.abrupt('return', bitId.toStringWithoutVersion());

              case 11:
              case 'end':
                return _context17.stop();
            }
          }
        }, _callee17, this);
      }));

      function removeSingle(_x29) {
        return _ref24.apply(this, arguments);
      }

      return removeSingle;
    }()
  }, {
    key: 'deprecateSingle',
    value: function () {
      var _ref25 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee18(bitId) {
        var component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee18$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                _context18.next = 2;
                return this.sources.get(bitId);

              case 2:
                component = _context18.sent;

                component.deprecated = true;
                this.objects.add(component);
                _context18.next = 7;
                return this.objects.persist();

              case 7:
                return _context18.abrupt('return', bitId.toStringWithoutVersion());

              case 8:
              case 'end':
                return _context18.stop();
            }
          }
        }, _callee18, this);
      }));

      function deprecateSingle(_x30) {
        return _ref25.apply(this, arguments);
      }

      return deprecateSingle;
    }()
    /**
     * findDependentBits
     * foreach component in array find the componnet that uses that component
     */

  }, {
    key: 'findDependentBits',
    value: function () {
      var _ref26 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee19(bitIds) {
        var allComponents, allConsumerComponents, dependentBits;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee19$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                _context19.next = 2;
                return this.objects.listComponents();

              case 2:
                allComponents = _context19.sent;
                _context19.next = 5;
                return this.toConsumerComponents(allComponents);

              case 5:
                allConsumerComponents = _context19.sent;
                dependentBits = {};

                bitIds.forEach(function (bitId) {
                  var dependencies = [];
                  allConsumerComponents.forEach(function (stagedComponent) {
                    stagedComponent.flattenedDependencies.forEach(function (flattendDependencie) {
                      if (flattendDependencie.toStringWithoutVersion() === bitId.toStringWithoutVersion()) {
                        dependencies.push(stagedComponent.id.toStringWithoutVersion());
                      }
                    });
                  });
                  if (!(_ramda || _load_ramda()).default.isEmpty(dependencies)) dependentBits[bitId.toStringWithoutVersion()] = dependencies;
                });
                return _context19.abrupt('return', Promise.resolve(dependentBits));

              case 9:
              case 'end':
                return _context19.stop();
            }
          }
        }, _callee19, this);
      }));

      function findDependentBits(_x31) {
        return _ref26.apply(this, arguments);
      }

      return findDependentBits;
    }()

    /**
     * split bit array to found and missing components (incase user misspelled id)
     */

  }, {
    key: 'filterFoundAndMissingComponents',
    value: function () {
      var _ref27 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee21(bitIds) {
        var _this22 = this;

        var missingComponents, foundComponents, resultP;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee21$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                missingComponents = [];
                foundComponents = [];
                resultP = bitIds.map(function () {
                  var _ref28 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee20(id) {
                    var component;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee20$(_context20) {
                      while (1) {
                        switch (_context20.prev = _context20.next) {
                          case 0:
                            _context20.next = 2;
                            return _this22.sources.get(id);

                          case 2:
                            component = _context20.sent;

                            if (!component) missingComponents.push(id.toStringWithoutVersion());else foundComponents.push(id);

                          case 4:
                          case 'end':
                            return _context20.stop();
                        }
                      }
                    }, _callee20, _this22);
                  }));

                  return function (_x33) {
                    return _ref28.apply(this, arguments);
                  };
                }());
                _context21.next = 5;
                return Promise.all(resultP);

              case 5:
                return _context21.abrupt('return', Promise.resolve({ missingComponents, foundComponents }));

              case 6:
              case 'end':
                return _context21.stop();
            }
          }
        }, _callee21, this);
      }));

      function filterFoundAndMissingComponents(_x32) {
        return _ref27.apply(this, arguments);
      }

      return filterFoundAndMissingComponents;
    }()

    /**
     * Remove components from scope
     * @force Boolean  - remove component from scope even if other components use it
     */

  }, {
    key: 'removeMany',
    value: function () {
      var _ref29 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee23(bitIds, force) {
        var _this23 = this;

        var _ref30, missingComponents, foundComponents, removeComponents, removedComponents, dependentBits, _removedComponents;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee23$(_context23) {
          while (1) {
            switch (_context23.prev = _context23.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`removing ${bitIds} with force flag: ${force}`);
                _context23.next = 3;
                return this.filterFoundAndMissingComponents(bitIds);

              case 3:
                _ref30 = _context23.sent;
                missingComponents = _ref30.missingComponents;
                foundComponents = _ref30.foundComponents;

                removeComponents = function removeComponents() {
                  return foundComponents.map(function () {
                    var _ref31 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee22(bitId) {
                      return (_regenerator || _load_regenerator()).default.wrap(function _callee22$(_context22) {
                        while (1) {
                          switch (_context22.prev = _context22.next) {
                            case 0:
                              return _context22.abrupt('return', _this23.removeSingle(bitId));

                            case 1:
                            case 'end':
                              return _context22.stop();
                          }
                        }
                      }, _callee22, _this23);
                    }));

                    return function (_x36) {
                      return _ref31.apply(this, arguments);
                    };
                  }());
                };

                if (!force) {
                  _context23.next = 12;
                  break;
                }

                _context23.next = 10;
                return Promise.all(removeComponents());

              case 10:
                removedComponents = _context23.sent;
                return _context23.abrupt('return', { bitIds: removedComponents });

              case 12:
                _context23.next = 14;
                return this.findDependentBits(foundComponents);

              case 14:
                dependentBits = _context23.sent;

                if (!(_ramda || _load_ramda()).default.isEmpty(dependentBits)) {
                  _context23.next = 20;
                  break;
                }

                _context23.next = 18;
                return Promise.all(removeComponents());

              case 18:
                _removedComponents = _context23.sent;
                return _context23.abrupt('return', { bitIds: _removedComponents, missingComponents });

              case 20:
                return _context23.abrupt('return', { dependentBits, missingComponents });

              case 21:
              case 'end':
                return _context23.stop();
            }
          }
        }, _callee23, this);
      }));

      function removeMany(_x34, _x35) {
        return _ref29.apply(this, arguments);
      }

      return removeMany;
    }()
    /**
     * deprecate components from scope
     */

  }, {
    key: 'deprecateMany',
    value: function () {
      var _ref32 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee25(bitIds) {
        var _this24 = this;

        var _ref33, missingComponents, foundComponents, deprecateComponents, deprecatedComponents;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee25$(_context25) {
          while (1) {
            switch (_context25.prev = _context25.next) {
              case 0:
                _context25.next = 2;
                return this.filterFoundAndMissingComponents(bitIds);

              case 2:
                _ref33 = _context25.sent;
                missingComponents = _ref33.missingComponents;
                foundComponents = _ref33.foundComponents;

                deprecateComponents = function deprecateComponents() {
                  return foundComponents.map(function () {
                    var _ref34 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee24(bitId) {
                      return (_regenerator || _load_regenerator()).default.wrap(function _callee24$(_context24) {
                        while (1) {
                          switch (_context24.prev = _context24.next) {
                            case 0:
                              return _context24.abrupt('return', _this24.deprecateSingle(bitId));

                            case 1:
                            case 'end':
                              return _context24.stop();
                          }
                        }
                      }, _callee24, _this24);
                    }));

                    return function (_x38) {
                      return _ref34.apply(this, arguments);
                    };
                  }());
                };

                _context25.next = 8;
                return Promise.all(deprecateComponents());

              case 8:
                deprecatedComponents = _context25.sent;
                return _context25.abrupt('return', { bitIds: deprecatedComponents, missingComponents });

              case 10:
              case 'end':
                return _context25.stop();
            }
          }
        }, _callee25, this);
      }));

      function deprecateMany(_x37) {
        return _ref32.apply(this, arguments);
      }

      return deprecateMany;
    }()
  }, {
    key: 'reset',
    value: function reset(_ref35) {
      var _this25 = this;

      var bitId = _ref35.bitId,
          consumer = _ref35.consumer;

      if (!bitId.isLocal(this.name)) {
        return Promise.reject('you can not reset a remote component');
      }
      return this.sources.get(bitId).then(function (component) {
        if (!component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(bitId.toString());
        var allVersions = component.listVersions();
        if (allVersions.length > 1) {
          var lastVersion = component.latest();
          bitId.version = lastVersion.toString();
          return consumer.removeFromComponents(bitId, true).then(function () {
            // TODO: this won't work any more because the version is now string (semver)
            bitId.version = (lastVersion - 1).toString();
            return _this25.get(bitId).then(function (consumerComponent) {
              var ref = component.versions[lastVersion];
              return _this25.objects.remove(ref).then(function () {
                // todo: remove also all deps of that ref
                delete component.versions[lastVersion];
                _this25.objects.add(component);
                return _this25.objects.persist();
              }).then(function () {
                return consumerComponent;
              });
            });
          });
        }
        return _this25.get(bitId).then(function (consumerComponent) {
          return consumer.removeFromComponents(bitId).then(function () {
            return _this25.clean(bitId).then(function () {
              return consumerComponent;
            });
          });
        });
      });
    }
  }, {
    key: 'loadRemoteComponent',
    value: function loadRemoteComponent(id) {
      var _this26 = this;

      return this.getOne(id).then(function (component) {
        if (!component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return component.toConsumer(_this26.objects);
      });
    }
  }, {
    key: 'loadComponent',
    value: function loadComponent(id) {
      (_logger || _load_logger()).default.debug(`scope.loadComponent, id: ${id}`);
      if (!id.isLocal(this.name)) {
        throw new Error('cannot load bit from remote scope, please import first');
      }

      return this.loadRemoteComponent(id);
    }
  }, {
    key: 'loadComponentLogs',
    value: function loadComponentLogs(id) {
      var _this27 = this;

      return this.sources.get(id).then(function (componentModel) {
        if (!componentModel) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return componentModel.collectLogs(_this27.objects);
      });
    }
  }, {
    key: 'loadAllVersions',
    value: function loadAllVersions(id) {
      var _this28 = this;

      return this.sources.get(id).then(function (componentModel) {
        if (!componentModel) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return componentModel.collectVersions(_this28.objects);
      });
    }
  }, {
    key: 'getOne',
    value: function () {
      var _ref36 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee26(id) {
        var _this29 = this;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee26$(_context26) {
          while (1) {
            switch (_context26.prev = _context26.next) {
              case 0:
                if (id.isLocal(this.name)) {
                  _context26.next = 2;
                  break;
                }

                return _context26.abrupt('return', this.remotes().then(function (remotes) {
                  return _this29.getExternalOne({ id, remotes, localFetch: true });
                }));

              case 2:
                return _context26.abrupt('return', this.sources.get(id).then(function (component) {
                  if (!component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
                  return component.toComponentVersion(id.version);
                }));

              case 3:
              case 'end':
                return _context26.stop();
            }
          }
        }, _callee26, this);
      }));

      function getOne(_x39) {
        return _ref36.apply(this, arguments);
      }

      return getOne;
    }()

    /**
     * Creates a symlink object with the local-scope which links to the real-object of the remote-scope
     * This way, local components that have dependencies to the exported component won't break.
     */

  }, {
    key: 'createSymlink',
    value: function createSymlink(id, remote) {
      var symlink = new (_models || _load_models()).Symlink({
        scope: id.scope,
        name: id.name,
        box: id.box,
        realScope: remote
      });
      return this.objects.add(symlink);
    }
  }, {
    key: 'exportMany',
    value: function () {
      var _ref37 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee28(ids, remoteName) {
        var _this30 = this;

        var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        var remotes, remote, componentIds, componentObjectsP, componentObjects, componentsAndObjects, manyObjectsP, manyObjects, exportedIds, idsWithRemoteScope;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee28$(_context28) {
          while (1) {
            switch (_context28.prev = _context28.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`exportMany, ids: ${ids.join(', ')}`);
                _context28.next = 3;
                return this.remotes();

              case 3:
                remotes = _context28.sent;
                _context28.next = 6;
                return remotes.resolve(remoteName, this);

              case 6:
                remote = _context28.sent;
                componentIds = ids.map(function (id) {
                  return (_bitId || _load_bitId()).BitId.parse(id);
                });
                componentObjectsP = componentIds.map(function (id) {
                  return _this30.sources.getObjects(id);
                });
                _context28.next = 11;
                return Promise.all(componentObjectsP);

              case 11:
                componentObjects = _context28.sent;
                componentsAndObjects = [];

                (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(context);
                manyObjectsP = componentObjects.map(function () {
                  var _ref38 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee27(componentObject) {
                    var componentAndObject, componentBuffer, objectsBuffer;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee27$(_context27) {
                      while (1) {
                        switch (_context27.prev = _context27.next) {
                          case 0:
                            componentAndObject = componentObject.toObjects(_this30.objects);

                            componentAndObject.component.local = false;
                            _this30._convertNonScopeToCorrectScope(componentAndObject, remoteName);
                            componentsAndObjects.push(componentAndObject);
                            _context27.next = 6;
                            return componentAndObject.component.compress();

                          case 6:
                            componentBuffer = _context27.sent;
                            _context27.next = 9;
                            return Promise.all(componentAndObject.objects.map(function (obj) {
                              return obj.compress();
                            }));

                          case 9:
                            objectsBuffer = _context27.sent;
                            return _context27.abrupt('return', new (_componentObjects || _load_componentObjects()).default(componentBuffer, objectsBuffer));

                          case 11:
                          case 'end':
                            return _context27.stop();
                        }
                      }
                    }, _callee27, _this30);
                  }));

                  return function (_x43) {
                    return _ref38.apply(this, arguments);
                  };
                }());
                _context28.next = 17;
                return Promise.all(manyObjectsP);

              case 17:
                manyObjects = _context28.sent;
                exportedIds = void 0;
                _context28.prev = 19;
                _context28.next = 22;
                return remote.pushMany(manyObjects, context);

              case 22:
                exportedIds = _context28.sent;

                (_logger || _load_logger()).default.debug('exportMany: successfully pushed all ids to the bare-scope, going to save them back to local scope');
                _context28.next = 30;
                break;

              case 26:
                _context28.prev = 26;
                _context28.t0 = _context28['catch'](19);

                (_logger || _load_logger()).default.warn('exportMany: failed pushing ids to the bare-scope');
                return _context28.abrupt('return', Promise.reject(_context28.t0));

              case 30:
                _context28.next = 32;
                return Promise.all(componentIds.map(function (id) {
                  return _this30.clean(id);
                }));

              case 32:
                componentIds.map(function (id) {
                  return _this30.createSymlink(id, remoteName);
                });
                idsWithRemoteScope = exportedIds.map(function (id) {
                  return (_bitId || _load_bitId()).BitId.parse(id);
                });
                _context28.next = 36;
                return Promise.all(componentsAndObjects.map(function (componentObject) {
                  return _this30.sources.merge(componentObject);
                }));

              case 36:
                _context28.next = 38;
                return this.objects.persist();

              case 38:
                return _context28.abrupt('return', idsWithRemoteScope);

              case 39:
              case 'end':
                return _context28.stop();
            }
          }
        }, _callee28, this, [[19, 26]]);
      }));

      function exportMany(_x41, _x42) {
        return _ref37.apply(this, arguments);
      }

      return exportMany;
    }()
  }, {
    key: 'ensureDir',
    value: function ensureDir() {
      var _this31 = this;

      (_fsExtra || _load_fsExtra()).default.ensureDirSync(this.getComponentsPath());
      return this.tmp.ensureDir().then(function () {
        return _this31.scopeJson.write(_this31.getPath());
      }).then(function () {
        return _this31.objects.ensureDir();
      }).then(function () {
        return _this31;
      });
    }
  }, {
    key: 'clean',
    value: function clean(bitId) {
      return this.sources.clean(bitId);
    }

    /**
     * sync method that loads the environment/(path to environment component)
     */

  }, {
    key: 'loadEnvironment',
    value: function () {
      var _ref39 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee29(bitId, opts) {
        var envPath, envFile;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee29$(_context29) {
          while (1) {
            switch (_context29.prev = _context29.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.loadEnvironment, id: ${bitId}`);

                if (bitId) {
                  _context29.next = 3;
                  break;
                }

                throw new (_exceptions || _load_exceptions()).ResolutionException();

              case 3:
                if (!(opts && opts.pathOnly)) {
                  _context29.next = 14;
                  break;
                }

                _context29.prev = 4;
                envPath = (0, (_componentResolver || _load_componentResolver()).default)(bitId.toString(), null, this.getPath());

                if (!(_fsExtra || _load_fsExtra()).default.existsSync(envPath)) {
                  _context29.next = 8;
                  break;
                }

                return _context29.abrupt('return', envPath);

              case 8:
                throw new Error(`Unable to find an env component ${bitId.toString()}`);

              case 11:
                _context29.prev = 11;
                _context29.t0 = _context29['catch'](4);
                throw new (_exceptions || _load_exceptions()).ResolutionException(_context29.t0.message);

              case 14:
                _context29.prev = 14;
                envFile = (0, (_componentResolver || _load_componentResolver()).default)(bitId.toString(), null, this.getPath());

                (_logger || _load_logger()).default.debug(`Requiring an environment file at ${envFile}`);
                return _context29.abrupt('return', require(envFile));

              case 20:
                _context29.prev = 20;
                _context29.t1 = _context29['catch'](14);
                throw new (_exceptions || _load_exceptions()).ResolutionException(_context29.t1);

              case 23:
              case 'end':
                return _context29.stop();
            }
          }
        }, _callee29, this, [[4, 11], [14, 20]]);
      }));

      function loadEnvironment(_x44, _x45) {
        return _ref39.apply(this, arguments);
      }

      return loadEnvironment;
    }()

    // TODO: Change name since it also used to install extension

  }, {
    key: 'installEnvironment',
    value: function () {
      var _ref41 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee31(_ref40) {
        var _this32 = this;

        var ids = _ref40.ids,
            verbose = _ref40.verbose;
        var componentsDir, isolateOpts, idsWithoutNils, isolateComponentsP;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee31$(_context31) {
          while (1) {
            switch (_context31.prev = _context31.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.installEnvironment, ids: ${ids.join(', ')}`);
                componentsDir = this.getComponentsPath();
                isolateOpts = {
                  writeBitDependencies: false,
                  installPackages: true,
                  noPackageJson: false,
                  dist: true,
                  conf: true,
                  override: false,
                  verbose
                };
                idsWithoutNils = removeNils(ids);
                isolateComponentsP = idsWithoutNils.map(function () {
                  var _ref42 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee30(id) {
                    var concreteId, concreteIds, dir, env;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee30$(_context30) {
                      while (1) {
                        switch (_context30.prev = _context30.next) {
                          case 0:
                            concreteId = id;

                            if (!id.getVersion().latest) {
                              _context30.next = 6;
                              break;
                            }

                            _context30.next = 4;
                            return _this32.fetchRemoteVersions([id]);

                          case 4:
                            concreteIds = _context30.sent;

                            concreteId = concreteIds[0];

                          case 6:
                            dir = (_path || _load_path()).join(componentsDir, Scope.getComponentRelativePath(concreteId));
                            env = new (_environment || _load_environment()).default(_this32, dir);
                            _context30.next = 10;
                            return env.create();

                          case 10:
                            return _context30.abrupt('return', env.isolateComponent(id, isolateOpts));

                          case 11:
                          case 'end':
                            return _context30.stop();
                        }
                      }
                    }, _callee30, _this32);
                  }));

                  return function (_x47) {
                    return _ref42.apply(this, arguments);
                  };
                }());
                return _context31.abrupt('return', Promise.all(isolateComponentsP));

              case 6:
              case 'end':
                return _context31.stop();
            }
          }
        }, _callee31, this);
      }));

      function installEnvironment(_x46) {
        return _ref41.apply(this, arguments);
      }

      return installEnvironment;
    }()
  }, {
    key: 'bumpDependenciesVersions',
    value: function () {
      var _ref43 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee33(componentsToUpdate, committedComponents, persist) {
        var _this33 = this;

        var componentsObjects, componentsToUpdateP, updatedComponentsAll, updatedComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee33$(_context33) {
          while (1) {
            switch (_context33.prev = _context33.next) {
              case 0:
                _context33.next = 2;
                return this.sources.getMany(componentsToUpdate);

              case 2:
                componentsObjects = _context33.sent;
                componentsToUpdateP = componentsObjects.map(function () {
                  var _ref44 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee32(componentObjects) {
                    var component, latestVersion, pendingUpdate, _message;

                    return (_regenerator || _load_regenerator()).default.wrap(function _callee32$(_context32) {
                      while (1) {
                        switch (_context32.prev = _context32.next) {
                          case 0:
                            component = componentObjects.component;

                            if (component) {
                              _context32.next = 3;
                              break;
                            }

                            return _context32.abrupt('return', null);

                          case 3:
                            _context32.next = 5;
                            return component.loadVersion(component.latest(), _this33.objects);

                          case 5:
                            latestVersion = _context32.sent;
                            pendingUpdate = false;

                            latestVersion.dependencies.forEach(function (dependency) {
                              var committedComponentId = committedComponents.find(function (committedComponent) {
                                return committedComponent.toStringWithoutVersion() === dependency.id.toStringWithoutVersion();
                              });

                              if (!committedComponentId) return;
                              if (persist && (_semver || _load_semver()).default.gt(committedComponentId.version, dependency.id.version)) {
                                pendingUpdate = true;
                                dependency.id.version = committedComponentId.version;
                                var flattenDependencyToUpdate = latestVersion.flattenedDependencies.find(function (flattenDependency) {
                                  return flattenDependency.toStringWithoutVersion() === dependency.id.toStringWithoutVersion();
                                });
                                flattenDependencyToUpdate.version = committedComponentId.version;
                              } else if (!persist && (_semver || _load_semver()).default.gte(committedComponentId.version, dependency.id.version)) {
                                // if !persist, we only check whether a modified component may cause auto-tagging
                                // since it's only modified on the file-system, its version might be the same as the version stored in its
                                // dependents. That's why "semver.gte" is used instead of "server.gt".
                                pendingUpdate = true;
                              }
                            });

                            if (!pendingUpdate) {
                              _context32.next = 13;
                              break;
                            }

                            if (persist) {
                              _context32.next = 11;
                              break;
                            }

                            return _context32.abrupt('return', componentObjects.component);

                          case 11:
                            _message = 'bump dependencies versions';
                            return _context32.abrupt('return', _this33.sources.putAdditionalVersion(componentObjects.component, latestVersion, _message));

                          case 13:
                            return _context32.abrupt('return', null);

                          case 14:
                          case 'end':
                            return _context32.stop();
                        }
                      }
                    }, _callee32, _this33);
                  }));

                  return function (_x51) {
                    return _ref44.apply(this, arguments);
                  };
                }());
                _context33.next = 6;
                return Promise.all(componentsToUpdateP);

              case 6:
                updatedComponentsAll = _context33.sent;
                updatedComponents = removeNils(updatedComponentsAll);

                if (!(!(_ramda || _load_ramda()).default.isEmpty(updatedComponents) && persist)) {
                  _context33.next = 11;
                  break;
                }

                _context33.next = 11;
                return this.objects.persist();

              case 11:
                return _context33.abrupt('return', updatedComponents);

              case 12:
              case 'end':
                return _context33.stop();
            }
          }
        }, _callee33, this);
      }));

      function bumpDependenciesVersions(_x48, _x49, _x50) {
        return _ref43.apply(this, arguments);
      }

      return bumpDependenciesVersions;
    }()
  }, {
    key: 'runComponentSpecs',
    value: function () {
      var _ref46 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee34(_ref45) {
        var bitId = _ref45.bitId,
            consumer = _ref45.consumer,
            environment = _ref45.environment,
            save = _ref45.save,
            verbose = _ref45.verbose,
            isolated = _ref45.isolated,
            directory = _ref45.directory,
            keep = _ref45.keep;
        var component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee34$(_context34) {
          while (1) {
            switch (_context34.prev = _context34.next) {
              case 0:
                if (bitId.isLocal(this.name)) {
                  _context34.next = 2;
                  break;
                }

                throw new Error('cannot run specs on remote component');

              case 2:
                _context34.next = 4;
                return this.loadComponent(bitId);

              case 4:
                component = _context34.sent;
                return _context34.abrupt('return', component.runSpecs({
                  scope: this,
                  consumer,
                  environment,
                  save,
                  verbose,
                  isolated,
                  directory,
                  keep
                }));

              case 6:
              case 'end':
                return _context34.stop();
            }
          }
        }, _callee34, this);
      }));

      function runComponentSpecs(_x52) {
        return _ref46.apply(this, arguments);
      }

      return runComponentSpecs;
    }()
  }, {
    key: 'build',
    value: function () {
      var _ref48 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee35(_ref47) {
        var bitId = _ref47.bitId,
            environment = _ref47.environment,
            save = _ref47.save,
            consumer = _ref47.consumer,
            verbose = _ref47.verbose,
            directory = _ref47.directory,
            keep = _ref47.keep,
            ciComponent = _ref47.ciComponent;
        var component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee35$(_context35) {
          while (1) {
            switch (_context35.prev = _context35.next) {
              case 0:
                if (bitId.isLocal(this.name)) {
                  _context35.next = 2;
                  break;
                }

                throw new Error('cannot run build on remote component');

              case 2:
                _context35.next = 4;
                return this.loadComponent(bitId);

              case 4:
                component = _context35.sent;
                return _context35.abrupt('return', component.build({ scope: this, environment, save, consumer, verbose, directory, keep, ciComponent }));

              case 6:
              case 'end':
                return _context35.stop();
            }
          }
        }, _callee35, this);
      }));

      function build(_x53) {
        return _ref48.apply(this, arguments);
      }

      return build;
    }()

    /**
     * import a component end to end. Including importing the dependencies and installing the npm
     * packages.
     *
     * @param {string} bitId - the component id to isolate
     * @param {IsolateOptions} opts
     * @return {Promise.<string>} - the path to the isolated component
     */

  }, {
    key: 'isolateComponent',
    value: function () {
      var _ref49 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee36(bitId, opts) {
        var parsedId, component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee36$(_context36) {
          while (1) {
            switch (_context36.prev = _context36.next) {
              case 0:
                parsedId = (_bitId || _load_bitId()).BitId.parse(bitId);
                _context36.next = 3;
                return this.loadComponent(parsedId);

              case 3:
                component = _context36.sent;
                return _context36.abrupt('return', component.isolate(this, opts));

              case 5:
              case 'end':
                return _context36.stop();
            }
          }
        }, _callee36, this);
      }));

      function isolateComponent(_x54, _x55) {
        return _ref49.apply(this, arguments);
      }

      return isolateComponent;
    }()
  }, {
    key: 'groupName',
    get: function get() {
      if (!this.scopeJson.groupName) return null;
      return this.scopeJson.groupName;
    }
  }, {
    key: 'name',
    get: function get() {
      return this.scopeJson.name;
    }
  }], [{
    key: 'getComponentsRelativePath',
    value: function getComponentsRelativePath() {
      return (_constants || _load_constants()).BITS_DIRNAME;
    }

    /**
     * Get a relative (to scope) path to a specific component such as compiler / tester / extension
     * @param {BitId} id
     */

  }, {
    key: 'getComponentRelativePath',
    value: function getComponentRelativePath(id) {
      return (_path || _load_path()).join(id.box, id.name, id.scope, id.version);
    }
  }, {
    key: 'ensure',
    value: function ensure() {
      var path = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : process.cwd();
      var name = arguments[1];
      var groupName = arguments[2];

      if (pathHasScope(path)) return this.load(path);
      if (!name) name = (0, (_utils || _load_utils()).currentDirName)();
      var scopeJson = new (_scopeJson || _load_scopeJson()).ScopeJson({ name, groupName, version: (_constants || _load_constants()).BIT_VERSION });
      return Promise.resolve(new Scope({ path, created: true, scopeJson }));
    }
  }, {
    key: 'load',
    value: function load(absPath) {
      var scopePath = (0, (_utils || _load_utils()).propogateUntil)(absPath, pathHasScope);
      if (!scopePath) throw new (_exceptions || _load_exceptions()).ScopeNotFound();
      if ((_fsExtra || _load_fsExtra()).default.existsSync((_path || _load_path()).join(scopePath, (_constants || _load_constants()).BIT_HIDDEN_DIR))) {
        scopePath = (_path || _load_path()).join(scopePath, (_constants || _load_constants()).BIT_HIDDEN_DIR);
      }
      var path = scopePath;

      return (0, (_utils || _load_utils()).readFile)((0, (_scopeJson || _load_scopeJson()).getPath)(scopePath)).then(function (rawScopeJson) {
        var scopeJson = (_scopeJson || _load_scopeJson()).ScopeJson.loadFromJson(rawScopeJson.toString());
        return new Scope({ path, scopeJson });
      });
    }
  }]);

  return Scope;
}();

exports.default = Scope;